unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ComCtrls, Ping, WinSock, WSocket, Contnrs, shellapi;

type
  TPingThread = class(TThread)
  private
    FPing: TPing;
    ThreadEnd: Boolean;
    procedure FLookupDone(Sender: TObject; Error: Word);
    procedure FPingEchoReply(Sender, Icmp: TObject; Error: Integer);
  protected
    procedure Execute; override;
  public
    TraAdr: string;
    TraTim: integer;
    TraSiz: integer;
    TraHop: integer;
    ResHop: integer;
    ResAdr: string;
    ResTim: integer;
    ResSte: boolean;
    ResLok: string;
    GenPing: boolean;
  end;

  TWSocketThread = class(TThread)
  private
    FWSocket: TWSocket;
    ThreadEnd: Boolean;
    procedure FLookupDone(Sender: TObject; Error: Word);
  protected
    procedure Execute; override;
  public
    TraHop: integer;
    TraAdr: string;
    ResHop: integer;
    ResSte: boolean;
    ResLok: string;
  end;

  TformMenuPrincipal = class(TForm)
    Panel1: TPanel;
    dlGuardar: TSaveDialog;
    be: TStatusBar;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    ipHost: TLabel;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    txtTamanoPaquete: TEdit;
    Label4: TLabel;
    Label8: TLabel;
    txtTiempoEspera: TEdit;
    Label3: TLabel;
    txtIntentosSalto: TEdit;
    Label1: TLabel;
    txtSaltos: TEdit;
    Label2: TLabel;
    txtHost: TComboBox;
    GroupBox3: TGroupBox;
    bIniciarTraza: TBitBtn;
    bCancelarTraza: TBitBtn;
    txtGuardar: TBitBtn;
    LWEB: TLabel;
    lsTraza: TListView;
    procedure bIniciarTrazaClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure bCancelarTrazaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure txtGuardarClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
  private
    PingThreads: TObjectList;
    WSocketThreads: TObjectList;
    TraceItem: TListItem;
    TraceHop: integer;
    TraceGen: integer;
    TraceTry: integer;
    LookAdr: string;
    RevTry: integer;
    RevGen: integer;
    procedure iniciarTraza;
    procedure iniciarLookupInverso;
    procedure PingThreadTerminate(Sender: TObject);
    procedure LookupThreadTerminate(Sender: TObject);
    procedure WSocketThreadTerminate(Sender: TObject);
    procedure prepararVentana;
  public
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.DFM}


// TPingThread
procedure TPingThread.Execute;
begin
  inherited;
  FPing := TPing.Create(nil);
  FPing.OnDnsLookupDone := FLookupDone;
  FPing.Timeout := TraTim;
  if GenPing = True then
  begin
    FPing.TTL:=TraHop;
    FPing.Size:=TraSiz;
    FPing.Address:=TraAdr;
    FPing.OnEchoReply:=FPingEchoReply;
    FPing.Ping;
  end
  else
    FPing.DnsLookup(TraAdr);
  while not Terminated do
  begin
    if ThreadEnd then
      break;
    Application.ProcessMessages;
  end;
  FPing.Destroy;
end;

procedure TPingThread.FLookupDone(Sender: TObject; Error: Word);
begin
  ResHop := TraHop;
  if Error <> 0 then
  begin
    ResLok := '';
    ResSte := False;
  end
  else
  begin
    with Sender as TPing do
      ResLok := DnsResult;
    ResSte := True;
  end;
  ThreadEnd := True;
end;

procedure TPingThread.FPingEchoReply(Sender, Icmp: TObject; Error: Integer);
begin
  with Sender as TPing do
  begin
    ResHop := TTL;
    if Error = 0 then
      ResSte := False
    else
    begin
      ResAdr := StrPas(inet_ntoa(TInAddr(Reply.Address)));
      ResTim := Reply.RTT;
      ResSte := True;
    end;
  end;
  ThreadEnd := True;
end;





procedure TformMenuPrincipal.PingThreadTerminate(Sender: TObject);
var
  num : integer;
begin
  if not Application.Terminated then
  begin
    with Sender as TPingThread do
    begin
      for num := 0 to lsTraza.Items.Count - 1 do
      begin
        if lsTraza.Items[num].Caption = IntToStr(ResHop) then
        begin
          if ResSte = False then
          begin
            if TraceTry = StrToIntDef(txtIntentosSalto.Text, 4) then
            begin
              lsTraza.Items[num].SubItems[0] := 'desconocido';
              lsTraza.Items[num].SubItems[1] := '';
              lsTraza.Items[num].SubItems[2] := '';
              lsTraza.Items[num].SubItems[3] := 'sin respuesta';
            end;
          end
          else
          begin
            lsTraza.Items[num].SubItems[0] := ResAdr;
            lsTraza.Items[num].SubItems[1] := IntToStr(ResTim);
            if ResAdr = LookAdr then
              lsTraza.Items[num].SubItems[3] := 'completado'
            else
              lsTraza.Items[num].SubItems[3] := 'siguiente';
          end;
        end;
      end;
    end;

    for num := 0 to PingThreads.count - 1 do
    begin
      if Sender = PingThreads[num] then
      begin
        PingThreads.Delete(num);
        break;
      end;
    end;

    inc(TraceHop);
    if TraceHop = TraceGen then
      iniciarTraza;
  end;
end;

procedure TformMenuPrincipal.LookupThreadTerminate(Sender: TObject);
var
  num : integer;
begin
  if not Application.Terminated then
  begin
    with Sender as TPingThread do
    begin
      if ResSte = True then
      begin
        LookAdr := ResLok;
        ipHost.Caption := LookAdr;
        iniciarTraza;
      end
      else
      begin
        ipHost.Caption := 'Error - Direccin desconocida';
        be.Panels[1].Text := 'Error - Direccin desconocida';
        lsTraza.Clear;
        prepararVentana;
        Exit;
      end;
    end;
    for num := 0 to PingThreads.count - 1 do
    begin
      if Sender = PingThreads[num] then
      begin
        PingThreads.Delete(num);
        break;
      end;
    end;
  end;
end;

procedure TformMenuPrincipal.bIniciarTrazaClick(Sender: TObject);
var
  salto : integer;
  t : TPingThread;
begin
  if txtHost.Text <> '' then
  begin
    lsTraza.Clear;
    bIniciarTraza.Enabled := False;
    bCancelarTraza.Enabled := True;
    txtSaltos.Enabled := False;
    txtIntentosSalto.Enabled := False;
    txtTiempoEspera.Enabled := False;
    txtTamanoPaquete.Enabled := False;
    txtHost.Enabled := False;
    for salto := 1 to StrToIntDef(txtSaltos.Text, 30) do
    begin
      with lsTraza do
      begin
        TraceItem:=Items.Add;
        TraceItem.Caption:=IntToStr(salto); // salto
        TraceItem.SubItems.Add('');       // IP        [0]
        TraceItem.SubItems.Add('');       // Tiempo    [1]
        TraceItem.SubItems.Add('');       // Host      [2]
        TraceItem.SubItems.Add('..1');    // Resultado [3]
      end;
    end;

    TraceTry := 0;

    //Buscando IP en servidores DNS
    ipHost.Caption := 'Obteniendo IP...';
    be.Panels[1].Text := 'Realizando traza...';
    t := TPingThread.create(true);
    with t do
    begin
      Priority := tpLowest;
      FreeOnTerminate := True;
      OnTerminate := LookupThreadTerminate;
      TraAdr := txtHost.Text;
      GenPing := False;
      ThreadEnd := False;
      PingThreads.add(t);
      Resume;
    end;

    ActiveControl := lsTraza;
  end
  else
  begin
    MessageDlg('Debe indicar una URL o hostname (nombre de red) para ' +
        'realizar la traza.', mtInformation, [mbok], 0);
    txtHost.SetFocus;
  end;
end;

procedure TformMenuPrincipal.iniciarTraza;
var
   salto, num : integer;
   t : TPingThread;
begin
  TraceHop := 0;
  TraceGen := 0;
  inc(TraceTry);
  if TraceTry <= StrToInt(txtIntentosSalto.Text) then
  begin
    for salto := 1 to StrToIntDef(txtSaltos.Text, 30) do
    begin
      if lsTraza.Items[salto - 1].SubItems[3][1] = '.' then
      begin
        lsTraza.Items[salto - 1].SubItems[3] := '..' + IntToStr(TraceTry);
        inc(TraceGen);
        t := TPingThread.create(true);
        with t do
        begin
          Priority := tpLowest;
          FreeOnTerminate := True;
          OnTerminate := PingThreadTerminate;
          TraAdr := LookAdr;
          TraTim := StrToIntDef(txtTiempoEspera.Text, 3000);
          TraSiz := StrToIntDef(txtTamanoPaquete.Text, 56);
          TraHop := salto;
          GenPing := True;
          ThreadEnd := False;
          PingThreads.add(t);
          Resume;
        end;
      end;
    end;
  end;
  if TraceGen = 0 then
  begin
    num := 0;
    for salto := 0 to lsTraza.Items.Count - 1 do
    begin
      if lsTraza.Items[salto].SubItems[0] = LookAdr then
      begin
        num := 1;
        break;
      end;
    end;
    inc(salto);
    if (num = 1) and (salto <= (lsTraza.Items.Count - 1)) then
    begin
      for num := lsTraza.Items.Count - 1 downto salto do
        lsTraza.Items[num].Delete;
    end;
    iniciarLookupInverso;
  end;
end;

procedure TformMenuPrincipal.iniciarLookupInverso;
var
  num : integer;
  t : TWSocketThread;
begin
  RevTry := 0;
  RevGen := 0;
  for num := 0 to lsTraza.Items.Count - 1 do
  begin
    if lsTraza.Items[num].SubItems[0] <> 'Desconocido' then
    begin
      inc(RevGen);
      lsTraza.Items[num].SubItems[2] := 'Obteniendo...';

      t := TWSocketThread.create(true);
      with t do
      begin
        Priority := tpLowest;
        FreeOnTerminate := True;
        OnTerminate := WSocketThreadTerminate;
        TraHop := StrToInt(lsTraza.Items[num].Caption);
        TraAdr := lsTraza.Items[num].SubItems[0];
        ThreadEnd := False;
        WSocketThreads.add(t);
        Resume;
      end;
    end
    else
      lsTraza.Items[num].SubItems[2] := 'Desconocido';
  end;
  if RevGen = 0 then
  begin
    prepararVentana;
    Exit;
  end;
end;





// TWSocketThread
procedure TWSocketThread.Execute;
begin
  inherited;
  FWSocket := TWSocket.Create(nil);
  FWSocket.OnDnsLookupDone := FLookupDone;
  FWSocket.ReverseDnsLookup(TraAdr);
  while not Terminated do
  begin
    if ThreadEnd then
      break;
    Application.ProcessMessages;
  end;
  FWSocket.Destroy;
end;

procedure TWSocketThread.FLookupDone(Sender: TObject; Error: Word);
begin
  ResHop := TraHop;
  if Error <> 0 then
  begin
    ResLok := '';
    ResSte := False;
  end
  else
  begin
    with Sender as TWSocket do
      ResLok := DnsResult;
      ResSte := True;
  end;
  ThreadEnd := True;
end;





procedure TformMenuPrincipal.WSocketThreadTerminate(Sender: TObject);
var
  num : integer;
begin
  if not Application.Terminated then
  begin
    with Sender as TWSocketThread do
    begin
      for num := 0 to lsTraza.Items.Count - 1 do
      begin
        if lsTraza.Items[num].Caption = IntToStr(ResHop) then
        begin
          if ResSte = True then
            lsTraza.Items.Item[num].SubItems[2]:=ResLok
          else
            lsTraza.Items.Item[num].SubItems[2]:=lsTraza.Items.Item[num].SubItems[0];
        end;
      end;
    end;
    for num := 0 to WSocketThreads.count - 1 do
    begin
      if Sender = WSocketThreads[num] then
      begin
        WSocketThreads.Delete(num);
        break;
      end;
    end;
    inc(RevTry);
    if RevTry = RevGen then
      prepararVentana;
  end;
end;

procedure TformMenuPrincipal.prepararVentana;
var
   i : integer;
begin
  for i := PingThreads.Count - 1 downto 0 do
  begin
    with TPingThread(PingThreads[i]) do
    begin
      Priority := tpNormal;
      FreeOnTerminate := False;
    end;
  end;

  for i := PingThreads.Count - 1 downto 0 do
  begin
    with TPingThread(PingThreads[i]) do
    begin
      OnTerminate := nil;
      Terminate;
    end;
    PingThreads.Delete(i);
  end;

  for i := WSocketThreads.Count - 1 downto 0 do
  begin
    with TWSocketThread(WSocketThreads[i]) do
    begin
      Priority := tpNormal;
      FreeOnTerminate := False;
    end;
  end;

  for i := WSocketThreads.Count - 1 downto 0 do
  begin
    with TWSocketThread(WSocketThreads[i]) do
    begin
      OnTerminate := nil;
      Terminate;
    end;
    WSocketThreads.Delete(i);
  end;

  bIniciarTraza.Enabled := True;
  bCancelarTraza.Enabled := False;
  txtSaltos.Enabled := True;
  txtIntentosSalto.Enabled := True;
  txtTiempoEspera.Enabled := True;
  txtTamanoPaquete.Enabled := True;
  txtHost.Enabled := True;

  be.Panels[1].Text := 'Traza finalizada';  
end;

procedure TformMenuPrincipal.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  prepararVentana;
end;

procedure TformMenuPrincipal.bCancelarTrazaClick(Sender: TObject);
begin
  prepararVentana;
end;

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
begin
  PingThreads := TObjectList.create(false);
  WSocketThreads := TObjectList.create(false);
end;

procedure TformMenuPrincipal.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  for i := PingThreads.Count - 1 downto 0 do
  begin
    with TPingThread(PingThreads[i]) do
    begin
      Priority := tpNormal;
      FreeOnTerminate := False;
    end;
  end;
  try
    for i:= PingThreads.Count - 1 downto 0 do
    begin
      with TPingThread(PingThreads[i]) do
      begin
        OnTerminate := nil;
        Terminate;
      end;
      PingThreads.Delete(i);
    end;
  finally
    PingThreads.Free;
  end;

  for i := WSocketThreads.Count - 1 downto 0 do
  begin
    with TWSocketThread(WSocketThreads[i]) do
    begin
      Priority := tpNormal;
      FreeOnTerminate := False;
    end;
  end;
  try
    for i:= WSocketThreads.Count - 1 downto 0 do
    begin
      with TWSocketThread(WSocketThreads[i]) do
      begin
        OnTerminate := nil;
        Terminate;
      end;
      WSocketThreads.Delete(i);
    end;
  finally
    WSocketThreads.Free;
  end;
end;

procedure TformMenuPrincipal.txtGuardarClick(Sender: TObject);
var
  Fp : TextFile;
  num : integer;
  sav : string;
begin
  dlGuardar.FileName := txtHost.Text + '.txt';
  if dlGuardar.Execute then
  begin
    sav := dlGuardar.FileName;
    AssignFile(Fp, sav);
    Rewrite(Fp);
    Writeln(Fp, 'Traceroute a ' + txtHost.text + ' IP: ' +
        ipHost.caption + #13#10);
    Writeln(Fp, '  Salto        IP        Tiempo     Host' + #13#10);
    for num := 0 to lsTraza.Items.Count - 1 do
    begin
      Writeln(Fp, Format('%4s  %15s  %5s  %s',
          [lsTraza.Items.Item[num].Caption,
          lsTraza.Items.Item[num].SubItems[0],
          lsTraza.Items.Item[num].SubItems[1],
          lsTraza.Items.Item[num].SubItems[2]]));
    end;
    CloseFile(Fp);
  end;
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
